/*
 * Amiga MUD
 *
 * Copyright (c) 1997 by Chris Gray
 *
 * CGMud Copyright (c) 2001 by Chris Gray
 */

/*
 * lex.h - define the lexical scanner interface.
 */

#define tk_eof			0
#define tk_illegal		(tk_eof + 1)
#define tk_newline		(tk_illegal + 1)
#define tk_dollar		(tk_newline + 1)
#define tk_intConst		(tk_dollar + 1)
#define tk_fixedConst		(tk_intConst + 1)
#define tk_stringConst		(tk_fixedConst + 1)
#define tk_identifier		(tk_stringConst + 1)
#define tk_equal		(tk_identifier + 1)
#define tk_notEqual		(tk_equal + 1)
#define tk_less 		(tk_notEqual + 1)
#define tk_greater		(tk_less + 1)
#define tk_lessOrEqual		(tk_greater + 1)
#define tk_greaterOrEqual	(tk_lessOrEqual + 1)
#define tk_equalEqual		(tk_greaterOrEqual + 1)
#define tk_assign		(tk_equalEqual + 1)
#define tk_plus 		(tk_assign + 1)
#define tk_minus		(tk_plus + 1)
#define tk_star 		(tk_minus + 1)
#define tk_slash		(tk_star + 1)
#define tk_percent		(tk_slash + 1)
#define tk_tilda		(tk_percent + 1)
#define tk_ampersand		(tk_tilda + 1)
#define tk_stick		(tk_ampersand + 1)
#define tk_xor			(tk_stick + 1)
#define tk_shiftLeft		(tk_xor + 1)
#define tk_shiftRight		(tk_shiftLeft + 1)
#define tk_leftParen		(tk_shiftRight + 1)
#define tk_rightParen		(tk_leftParen + 1)
#define tk_comma		(tk_rightParen + 1)
#define tk_semicolon		(tk_comma + 1)
#define tk_colon		(tk_semicolon + 1)
#define tk_at			(tk_colon + 1)
#define tk_minusMinus		(tk_at + 1)
#define tk_leftSquare		(tk_minusMinus + 1)
#define tk_rightSquare		(tk_leftSquare + 1)
#define tk_and			(tk_rightSquare + 1)
#define tk_or			(tk_and + 1)
#define tk_not			(tk_or + 1)
#define tk_if			(tk_not + 1)
#define tk_then 		(tk_if + 1)
#define tk_elif 		(tk_then + 1)
#define tk_else 		(tk_elif + 1)
#define tk_fi			(tk_else + 1)
#define tk_while		(tk_fi + 1)
#define tk_do			(tk_while + 1)
#define tk_od			(tk_do + 1)
#define tk_for			(tk_od + 1)
#define tk_from 		(tk_for + 1)
#define tk_upto 		(tk_from + 1)
#define tk_case 		(tk_upto + 1)
#define tk_incase		(tk_case + 1)
#define tk_default		(tk_incase + 1)
#define tk_esac 		(tk_default + 1)
#define tk_ignore		(tk_esac + 1)
#define tk_call 		(tk_ignore + 1)
#define tk_note 		(tk_call + 1)
#define tk_proc 		(tk_note + 1)
#define tk_utility		(tk_proc + 1)
#define tk_wizard		(tk_utility + 1)
#define tk_public		(tk_wizard + 1)
#define tk_compiled		(tk_public + 1)
#define tk_stripped		(tk_compiled + 1)
#define tk_corp 		(tk_stripped + 1)
#define tk_void 		(tk_corp + 1)
#define tk_bool 		(tk_void + 1)
#define tk_int			(tk_bool + 1)
#define tk_fixed		(tk_int + 1)
#define tk_string		(tk_fixed + 1)
#define tk_thing		(tk_string + 1)
#define tk_status		(tk_thing + 1)
#define tk_grammar		(tk_status + 1)
#define tk_player		(tk_grammar + 1)
#define tk_table		(tk_player + 1)
#define tk_action		(tk_table + 1)
#define tk_list 		(tk_action + 1)
#define tk_property		(tk_list + 1)
#define tk_true 		(tk_property + 1)
#define tk_false		(tk_true + 1)
#define tk_succeed		(tk_false + 1)
#define tk_fail 		(tk_succeed + 1)
#define tk_continue		(tk_fail + 1)
#define tk_nil			(tk_continue + 1)
#define tk_ts_private		(tk_nil + 1)
#define tk_ts_readonly		(tk_ts_private + 1)
#define tk_ts_wizard		(tk_ts_readonly + 1)
#define tk_ts_public		(tk_ts_wizard + 1)
